Bug 1889271 (CVE-2020-14779) - CVE-2020-14779 OpenJDK: High memory usage during deserialization of Proxy class with many interfaces (Serialization, 8236862)
Summary: CVE-2020-14779 OpenJDK: High memory usage during deserialization of Proxy cla...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2020-14779
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1879738 1879847 1879737 1879845 1879846 1879997 1879998 1879999 1880001 1881127 1881128 1881129 1881130
Blocks: 1876666
TreeView+ depends on / blocked
 
Reported: 2020-10-19 08:41 UTC by Tomas Hoger
Modified: 2020-10-27 00:40 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-10-22 14:21:14 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2020:4305 None None None 2020-10-22 11:06:42 UTC
Red Hat Product Errata RHSA-2020:4306 None None None 2020-10-22 10:50:13 UTC
Red Hat Product Errata RHSA-2020:4307 None None None 2020-10-22 16:03:20 UTC
Red Hat Product Errata RHSA-2020:4316 None None None 2020-10-22 19:40:09 UTC
Red Hat Product Errata RHSA-2020:4347 None None None 2020-10-26 20:28:39 UTC
Red Hat Product Errata RHSA-2020:4348 None None None 2020-10-27 00:34:19 UTC
Red Hat Product Errata RHSA-2020:4349 None None None 2020-10-26 20:00:46 UTC
Red Hat Product Errata RHSA-2020:4350 None None None 2020-10-27 00:40:52 UTC
Red Hat Product Errata RHSA-2020:4352 None None None 2020-10-26 21:10:25 UTC

Description Tomas Hoger 2020-10-19 08:41:34 UTC
It was discovered that the implementation of the Proxy class in the Serialization component of OpenJDK could trigger an out-of-memory condition when deserializing Proxy class objects with many interfaces.  A specially-crafted input could cause a Java application to use an excessive amount of memory when deserialized.

The patch for this issue adds a new system property jdk.serialProxyInterfaceLimit that can be used to reduce the limit for Proxy interfaces from the default of 65535 and hence better protect against excessive memory usage.

Comment 1 Tomas Hoger 2020-10-20 20:54:46 UTC
Public now via Oracle CPU October 2020:

https://www.oracle.com/security-alerts/cpuoct2020.html#AppendixJAVA

Fixed in Oracle Java SE 15.0.1, 11.0.9, 8u271, and 7u281.

Comment 2 Tomas Hoger 2020-10-20 21:07:31 UTC
Related note in the Oracle Java SE release notes:

core-libs/java.io:serialization
➜ Enhanced Support of Proxy Class

The deserialization of java.lang.reflect.Proxy objects can be limited by setting the system property jdk.serialProxyInterfaceLimit. The limit is the maximum number of interfaces allowed per Proxy in the stream. Setting the limit to zero prevents any Proxies from being deserialized including Annotations, a limit of less than 2 might interfere with RMI operations.

JDK-8236862 (not public)

https://www.oracle.com/java/technologies/javase/15-0-1-relnotes.html
https://www.oracle.com/java/technologies/javase/11-0-9-relnotes.html
https://www.oracle.com/java/technologies/javase/8u271-relnotes.html
https://www.oracle.com/java/technologies/javase/7-support-relnotes.html#R170_281

Comment 12 errata-xmlrpc 2020-10-22 10:50:11 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.1 Extended Update Support

Via RHSA-2020:4306 https://access.redhat.com/errata/RHSA-2020:4306

Comment 13 errata-xmlrpc 2020-10-22 11:06:38 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2020:4305 https://access.redhat.com/errata/RHSA-2020:4305

Comment 14 Product Security DevOps Team 2020-10-22 14:21:14 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2020-14779

Comment 15 errata-xmlrpc 2020-10-22 16:03:18 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2020:4307 https://access.redhat.com/errata/RHSA-2020:4307

Comment 17 errata-xmlrpc 2020-10-22 19:40:08 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.0 Update Services for SAP Solutions

Via RHSA-2020:4316 https://access.redhat.com/errata/RHSA-2020:4316

Comment 18 Tomas Hoger 2020-10-23 21:08:56 UTC
OpenJDK-11 upstream commit:
http://hg.openjdk.java.net/jdk-updates/jdk11u/rev/2a2df11c0684

OpenJDK-8 upstream commit:
http://hg.openjdk.java.net/jdk8u/jdk8u/jdk/rev/0da7153533e6

Comment 25 errata-xmlrpc 2020-10-26 20:00:44 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.0 Update Services for SAP Solutions

Via RHSA-2020:4349 https://access.redhat.com/errata/RHSA-2020:4349

Comment 26 errata-xmlrpc 2020-10-26 20:28:38 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2020:4347 https://access.redhat.com/errata/RHSA-2020:4347

Comment 27 errata-xmlrpc 2020-10-26 21:10:23 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.1 Extended Update Support

Via RHSA-2020:4352 https://access.redhat.com/errata/RHSA-2020:4352

Comment 28 errata-xmlrpc 2020-10-27 00:34:16 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6

Via RHSA-2020:4348 https://access.redhat.com/errata/RHSA-2020:4348

Comment 29 errata-xmlrpc 2020-10-27 00:40:50 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2020:4350 https://access.redhat.com/errata/RHSA-2020:4350


Note You need to log in before you can comment on or make changes to this bug.